
-- ******************************************************
-- * wedgewars                                     v0.1 *
-- * =-=-=-=-=                                          *
-- *                                                    *
-- * Another ropey bit of Lua homebrew by alex carroll! *
-- *                                   11th August 2005 *
-- *                                                    *
-- * Uses Shine's amazing LuaPlayer 0.7b (i think) see  *
-- * forums.ps2dev.org for the latest version           *
-- ******************************************************

-- ******************************************************
-- * Shine might have his own thoughts on LuaPlayer's   *
-- * copyright but THIS CODE may NOT appear on any eBay *
-- * auction or ANY pre-built memory stick if any cash  * 
-- * or other monetary value changes hands.  It's FREE! * 
-- ******************************************************

-- *** See readme for any additional info ***

-- ******************************************************

local bg_start = Image.load("tanx_intro.png")
local bg = Image.load("tanx_back.png")

-- ******************************************************
-- * load initial graphics (not a very visual game ;) ) *
-- ******************************************************

tcol = Color.new(255,255,255)
tcoldead = Color.new(255,64,64)
bcol = Color.new(0,0,0)

-- ******************************************************
-- * colour setup: tcol = tank, bcol = background       *
-- *               tcoldead = hit tank                  *
-- ******************************************************

local keyin = Controls.read()

screen:blit(0,0,bg_start)
screen.flip()

while true do
	local keyin = Controls.read()
	if keyin:start() then
		break
	end
	screen.waitVblankStart()
end

screen:clear(bcol)

-- ******************************************************
-- * splash screen (waits for start button)             *
-- ******************************************************

gravity=.75
wind=0
screenshake=0
windmove=1

-- ******************************************************
-- * variables relevant to both players                 *
-- * windmove is just for a random number, but try      *
-- * playing around with gravity for different results. *
-- ******************************************************

shipx=20
shipy=251

power=1
shells=100
score=0

bulletx=shipx+10
bullety=shipy-5
bullethold=0
angle=45
bulletfired=0
bullettime=1
dead=0
deadtime=0

-- ******************************************************
-- * variables relevant to player one                   *
-- ******************************************************

shipx2=460
shipy2=251

power2=1
shells2=100
score2=0

bulletx2=shipx2-10
bullety2=shipy2-5
bullethold2=0
angle2=45
bulletfired2=0
bullettime2=1
dead2=0
deadtime2=0

-- ******************************************************
-- * variables relevant to player two                   *
-- ******************************************************

math.randomseed( os.time() ) 

screen:blit(0,0,bg)

local lastkeyin = Controls.read()

voice = 0
SoundSystem.SFXVolume(128) 
SoundSystem.reverb(4) 
SoundSystem.panoramicSeparation(128) 

local sound_fire = Sound.load("fire.wav") 
local sound_land = Sound.load("land.wav") 

-- ******************************************************
-- * first run sound file setup and init                *
-- ******************************************************

while true do

	if deadtime>60 then 
		deadtime=0
		dead=0
	end

	if deadtime2>60 then 
		deadtime2=0
		dead2=0
	end

-- ******************************************************
-- * hit wedges stay hit for 60 clicks (1 second?)      *
-- ******************************************************

	if screenshake==0 then 
		screen:blit(0,0,bg) 
	end
	if screenshake==4 then 
		screen:blit(0,-1,bg)
		screenshake=0 
	end
	if screenshake==3 then 
		screen:blit(0,1,bg) 
		screenshake=4
	end
	if screenshake==2 then 
		screen:blit(0,-2,bg) 
		screenshake=3
	end
	if screenshake==1 then 
		screen:blit(0,2,bg) 
		screenshake=2
	end

-- ******************************************************
-- * really crappy code to make the screen bounce when  *
-- * a bullet lands on the ground... :p                 *
-- ******************************************************

	screen:drawLine(0,252,480,252,tcol)
	screen:drawLine(240,252,240,212,tcol)

-- ******************************************************
-- * draws horizontal ground and the centre pole        *
-- ******************************************************

	local keyin = Controls.read()

	if keyin:left() and shipx>20 then shipx=shipx-1 end
	if keyin:right() and shipx<220 then shipx=shipx+1 end
	if keyin:up() and angle<90 then angle=angle+1 end
	if keyin:down() and angle>0 then angle=angle-1 end

-- ******************************************************

	if keyin:square() and shipx2>260 then shipx2=shipx2-1 end
	if keyin:circle() and shipx2<460 then shipx2=shipx2+1 end
	if keyin:triangle() and angle2<90 then angle2=angle2+1 end
	if keyin:cross() and angle2>0 then angle2=angle2-1 end

-- ******************************************************
-- * movement and aiming (dead simple)                  *
-- ******************************************************

	if keyin:l() and bulletfired==0 and shells>0 and bullethold==0 then
		bullethold=1
		power=1
	end

	if keyin:l() and bullethold==1 then
		power=power+0.01
	end

	if (not keyin:l() and bullethold==1) or (power>2 and bullethold==1) then
		bullethold=2
	end

-- ******************************************************

	if keyin:r() and bulletfired2==0 and shells2>0 and bullethold2==0 then
		bullethold2=1
		power2=1
	end

	if keyin:r() and bullethold2==1 then
		power2=power2+0.01
	end

	if (not keyin:r() and bullethold2==1) or (power2>2 and bullethold2==1) then
		bullethold2=2
	end

-- ******************************************************
-- * the hold trigger method of firing                  *
-- ******************************************************

	if bullethold==2 then
		shells=shells-1
		bulletfired=1
		bulletx=shipx+10+(20*math.cos(math.rad(angle)))
		bullety=shipy-5-(20*math.sin(math.rad(angle)))
		bulletangle=angle
		velocity=power
		bullettime=1
		bullethold=0
		voice = sound_fire:play()
		voice:pan(0)
		voice:volume(255)
		voice:frequency(11000)
	end

-- ******************************************************

	if bullethold2==2 then
		shells2=shells2-1
		bulletfired2=1
		bulletx2=shipx2-10-(20*math.cos(math.rad(angle2)))
		bullety2=shipy2-5-(20*math.sin(math.rad(angle2)))
		bulletangle2=angle2
		velocity2=power2
		bullettime2=1
		bullethold2=0
		voice = sound_fire:play()
		voice:pan(255)
		voice:volume(255)
		voice:frequency(11000)
	end

-- ******************************************************
-- * when the trigger is released:                      *
-- * 1. reduces number of shells by one                 *
-- * 2. sets bulletfired to 1 so we know what's what    *
-- * 3. works out the initial location of the shell     *
-- * 4. plays a sound (through l or r speaker)          *
-- ******************************************************

	if bulletfired==1 then
		bullettime=bullettime+0.075
		bulletx=bulletx+(velocity*(math.cos(math.rad(bulletangle)))*bullettime)+wind
		bullety=bullety-(velocity*((math.sin(math.rad(bulletangle)))*bullettime)-0.5*((gravity*bullettime)^2))
		if bullety>252 then 
			bulletfired=0 
			voice = sound_land:play()
			voice:pan(128)
			voice:volume(255)
			voice:frequency(11000)
			screenshake=1
			power=1	
			if bulletx>shipx and bulletx<shipx+20 then 
				dead=1
				score=score-1
			end		
			if bulletx>shipx2-20 and bulletx<shipx2 then 
				dead2=1
				score=score+1
			end		
		end
		if bulletx<0 then bulletfired=0 end
		if bulletx>479 then bulletfired=0 end
		if bulletfired==1 and bullety>0 then screen:pixel(bulletx, bullety, tcol) end
		if bulletfired==1 and bullety>0 then screen:pixel(bulletx+1, bullety, tcol) end
		if bulletfired==1 and bullety>0 then screen:pixel(bulletx, bullety+1, tcol) end
		if bulletfired==1 and bullety>0 then screen:pixel(bulletx+1, bullety+1, tcol) end
	end 

-- ******************************************************

	if bulletfired2==1 then
		bullettime2=bullettime2+0.075
		bulletx2=bulletx2-(velocity2*(math.cos(math.rad(bulletangle2)))*bullettime2)+wind
		bullety2=bullety2-(velocity2*((math.sin(math.rad(bulletangle2)))*bullettime2)-0.5*((gravity*bullettime2)^2))
		if bullety2>252 then 
			bulletfired2=0 
			voice = sound_land:play()
			voice:pan(128)
			voice:volume(255)
			voice:frequency(11000)
			screenshake=1
			power2=1	
			if bulletx2>shipx and bulletx2<shipx+20 then 
				dead=1
				score2=score2+1
			end		
			if bulletx2>shipx2-20 and bulletx2<shipx2 then 
				dead2=1
				score2=score2-1
			end		
		end
		if bulletx2<0 then bulletfired2=0 end
		if bulletx2>479 then bulletfired2=0 end
		if bulletfired2==1 and bullety2>0 then screen:pixel(bulletx2, bullety2, tcol) end
		if bulletfired2==1 and bullety2>0 then screen:pixel(bulletx2+1, bullety2, tcol) end
		if bulletfired2==1 and bullety2>0 then screen:pixel(bulletx2, bullety2+1, tcol) end
		if bulletfired2==1 and bullety2>0 then screen:pixel(bulletx2+1, bullety2+1, tcol) end
	end 

-- ******************************************************
-- * working out the bullet path and contact            *
-- * plays a sound if the shell hits the ground         *
-- * note: shell can go through the roof and then come  *
-- *       back down, but it doesn't plot it if y < 0   *
-- ******************************************************

	-- windmove=math.random(1,10)
	-- if windmove==1 and wind >- 5 then wind=wind-0.1 end
	-- if windmove==2 and wind < 5 then wind=wind+0.1 end

-- ******************************************************
-- * wind stuff (not used yet as it's a bit shit)       *
-- * uncomment if you want to see it (0.1 might be low) *
-- ******************************************************

if dead==0 then
	screen:drawLine(shipx,shipy,shipx+20,shipy,tcol)
	screen:drawLine(shipx,shipy,shipx,shipy-10,tcol)
	screen:drawLine(shipx,shipy-10,shipx+20,shipy,tcol)
else
	screen:drawLine(shipx,shipy,shipx+20,shipy,tcoldead)
	screen:drawLine(shipx,shipy,shipx,shipy-10,tcoldead)
	screen:drawLine(shipx,shipy-10,shipx+20,shipy,tcoldead)
	deadtime=deadtime+1
end

-- ******************************************************

if dead2==0 then
	screen:drawLine(shipx2,shipy2,shipx2-20,shipy2,tcol)
	screen:drawLine(shipx2,shipy2,shipx2,shipy2-10,tcol)
	screen:drawLine(shipx2,shipy2-10,shipx2-20,shipy2,tcol)
else
	screen:drawLine(shipx2,shipy2,shipx2-20,shipy2,tcoldead)
	screen:drawLine(shipx2,shipy2,shipx2,shipy2-10,tcoldead)
	screen:drawLine(shipx2,shipy2-10,shipx2-20,shipy2,tcoldead)
	deadtime2=deadtime2+1
end

-- ******************************************************
-- * draw the two tanks (wedges)                        *
-- ******************************************************

	screen:drawLine(shipx+10, shipy-5, shipx+10+(20*math.cos(math.rad(angle))), shipy-5-(20*math.sin(math.rad(angle))),tcol)

-- ******************************************************

	screen:drawLine(shipx2-10, shipy2-5, shipx2-10-(20*math.cos(math.rad(angle2))), shipy2-5-(20*math.sin(math.rad(angle2))),tcol)

-- ******************************************************
-- * and the two turrets (trig 101 lol)                 *
-- ******************************************************

	-- lastkeyin = keyin	

	screen:print(20,20,"angle: "..angle, tcol)
	screen:print(20,30,"power: "..(power-1)*100, tcol)		
	screen:print(20,40,"shells: "..shells, tcol)
	screen:print(20,50,"score: "..score, tcol)

-- ******************************************************

	screen:print(380,20,"angle: "..angle2, tcol)
	screen:print(380,30,"power: "..(power2-1)*100, tcol)		
	screen:print(380,40,"shells: "..shells2, tcol)
	screen:print(380,50,"score: "..score2, tcol)	

-- ******************************************************
-- * hud stuff, not very pretty but works ok            *
-- ******************************************************

	screen.flip()
	screen.waitVblankStart(1)

-- ******************************************************
-- * and back we go.  should run at 60fps at the moment *
-- ******************************************************

end

-- eof/
